%define _with_mpeg 0
%define _with_flac 0
%define _with_qt 0
%define _with_gtk 0

%global plugindir	%_libdir/%name

%{!?release_func:%global release_func() %1%{?dist}}

Name:		libextractor
Version:	0.5.22
Release:	%release_func 2
Summary:	Simple library for keyword extraction

Group:		System Environment/Libraries
License:	GPLv2+
URL:		http://gnunet.org/libextractor/
Source0:	http://gnunet.org/libextractor/download/%name-%version.tar.gz
#Source1:	http://gnunet.org/libextractor/download/%name-%version.tar.gz.sig
Source10:	README.fedora
BuildRoot:	%_tmppath/%name-%version-%release-root

BuildRequires:	gettext
BuildRequires:	libtool libvorbis-devel
BuildRequires:	bzip2-devel zlib-devel
BuildRequires:	libgsf-devel
Requires(post):		/sbin/install-info
Requires(preun):	/sbin/install-info

%package devel
Summary:	Development files for %name
Group:		Development/Libraries
Requires:	%name = %version-%release
Requires:	%_libdir/pkgconfig


%package plugins
Summary:	Plugins for libextractor
Group:		System Environment/Libraries
Requires:	%name = %version-%release
Requires:	%name-plugins-base
Requires:	%name-plugins-exiv2
Requires:	%name-plugins-ogg
Requires:	%name-plugins-ole2
Requires:	%name-plugins-pdf
%if %{_with_flac}
Requires:	%name-plugins-flac
%endif
%if %{_with_gtk}
Requires:	%name-plugins-thumbnailgtk
%endif
%if %{_with_qt}
Requires:   %name-plugins-thumbnailqt
%endif
#Requires:	%name-plugins-rpm


%package plugins-base
Summary:	Base plugins for libextractor
Group:		System Environment/Libraries
Requires:	%name = %version-%release

%if %{_with_mpeg}
%package plugins-mpeg
Summary:	The 'mpeg' libextractor plugin
Group:		System Environment/Libraries
Provides:	plugin(%name) = mpeg
BuildRequires:	mpeg2dec-devel
Requires:	%name = %version-%release

%description plugins-mpeg
libextractor is a simple library for keyword extraction.  libextractor
does not support all formats but supports a simple plugging mechanism
such that you can quickly add extractors for additional formats, even
without recompiling libextractor.

This package ships the 'mpeg' plugin.

%files plugins-mpeg
%defattr(-,root,root,-)
%plugindir/libextractor_mpeg.so*
%nil
%endif

%if %{_with_flac}
%package plugins-flac
Summary:	The 'flac' libextractor plugin
Group:		System Environment/Libraries
Provides:	plugin(%name) = flac
BuildRequires:	flac-devel
Requires:	%name = %version-%release

%description plugins-flac
libextractor is a simple library for keyword extraction.  libextractor
does not support all formats but supports a simple plugging mechanism
such that you can quickly add extractors for additional formats, even
without recompiling libextractor.

This package ships the 'flac' plugin.

%files plugins-flac
%defattr(-,root,root,-)
%plugindir/libextractor_flac.so*
%nil
%endif

%package plugins-exiv2
Summary:	The 'exiv2' libextractor plugin
Group:		System Environment/Libraries
Provides:	plugin(%name) = exiv2
Requires:	%name = %version-%release

%description plugins-exiv2
libextractor is a simple library for keyword extraction.  libextractor
does not support all formats but supports a simple plugging mechanism
such that you can quickly add extractors for additional formats, even
without recompiling libextractor.

This package ships the 'exiv2' plugin.

%files plugins-exiv2
%defattr(-,root,root,-)
%plugindir/libextractor_exiv2.so*
%nil

%package plugins-ogg
Summary:	The 'ogg' libextractor plugin
Group:		System Environment/Libraries
Provides:	plugin(%name) = ogg
Requires:	%name = %version-%release

%description plugins-ogg
libextractor is a simple library for keyword extraction.  libextractor
does not support all formats but supports a simple plugging mechanism
such that you can quickly add extractors for additional formats, even
without recompiling libextractor.

This package ships the 'ogg' plugin.

%files plugins-ogg
%defattr(-,root,root,-)
%plugindir/libextractor_ogg.so*
%nil

%package plugins-ole2
Summary:	The 'ole2' libextractor plugin
Group:		System Environment/Libraries
Provides:	plugin(%name) = ole2
Requires:	%name = %version-%release

%description plugins-ole2
libextractor is a simple library for keyword extraction.  libextractor
does not support all formats but supports a simple plugging mechanism
such that you can quickly add extractors for additional formats, even
without recompiling libextractor.

This package ships the 'ole2' plugin.

%files plugins-ole2
%defattr(-,root,root,-)
%plugindir/libextractor_ole2.so*
%nil

%package plugins-pdf
Summary:	The 'pdf' libextractor plugin
Group:		System Environment/Libraries
Provides:	plugin(%name) = pdf
Requires:	%name = %version-%release

%description plugins-pdf
libextractor is a simple library for keyword extraction.  libextractor
does not support all formats but supports a simple plugging mechanism
such that you can quickly add extractors for additional formats, even
without recompiling libextractor.

This package ships the 'pdf' plugin.

%files plugins-pdf
%defattr(-,root,root,-)
%plugindir/libextractor_pdf.so*
%nil

%if %{_with_gtk}
%package plugins-thumbnailgtk
Summary:	The 'thumbnailgtk' libextractor plugin
Group:		System Environment/Libraries
Provides:	plugin(%name) = thumbnailgtk plugin(%name)=thumbnail
Requires:	%name = %version-%release
Requires(post):   /usr/sbin/update-alternatives
Requires(preun):  /usr/sbin/update-alternatives

%description plugins-thumbnailgtk
libextractor is a simple library for keyword extraction.  libextractor
does not support all formats but supports a simple plugging mechanism
such that you can quickly add extractors for additional formats, even
without recompiling libextractor.

This package ships the 'thumbnailgtk' plugin.

%files plugins-thumbnailgtk
%defattr(-,root,root,-)
%plugindir/libextractor_thumbnailgtk.so*
%nil
%ghost %plugindir/libextractor-thumbnail.so
%endif

%if %{_with_qt}
%package plugins-qt
Summary:	The 'qt' libextractor plugin
Group:		System Environment/Libraries
Provides:	plugin(%name) = qt plugin(%name)=thumbnail
Requires:	%name = %version-%release
Requires(post):   /usr/sbin/update-alternatives
Requires(preun):  /usr/sbin/update-alternatives
BuildRequires:	qt4-devel

%description plugins-qt
libextractor is a simple library for keyword extraction.  libextractor
does not support all formats but supports a simple plugging mechanism
such that you can quickly add extractors for additional formats, even
without recompiling libextractor.

This package ships the 'qt' plugin.

%files plugins-qt
%defattr(-,root,root,-)
%plugindir/libextractor_qt.so*
%nil
%ghost %plugindir/libextractor-thumbnail.so
%endif


%description
libextractor is a simple library for keyword extraction.  libextractor
does not support all formats but supports a simple plugging mechanism
such that you can quickly add extractors for additional formats, even
without recompiling libextractor.  libextractor typically ships with a
dozen helper-libraries that can be used to obtain keywords from common
file-types.

libextractor is a part of the GNU project (http://www.gnu.org/).


%description plugins
libextractor is a simple library for keyword extraction.  libextractor
does not support all formats but supports a simple plugging mechanism
such that you can quickly add extractors for additional formats, even
without recompiling libextractor.

This is a metapackage which requires all supported plugins for
libextractor.

%description plugins-base
libextractor is a simple library for keyword extraction.  libextractor
does not support all formats but supports a simple plugging mechanism
such that you can quickly add extractors for additional formats, even
without recompiling libextractor.

This package contains all plugins for libextractor which do not
introduce additional dependencies.


%description devel
The %name-devel package contains libraries and header files for
developing applications that use %name.


%prep
%setup -q

install -pm644 %SOURCE10 .
rm -f README.debian

sed -i 's!\(-L\(/usr\|\$with_qt\)/lib\|-I/usr/include\) !!g' configure

%build
%if !%{_with_mpeg}
export ac_cv_lib_mpeg2_mpeg2_init=no
%endif
export ac_cv_lib_rpm_rpmReadPackageFile=no

%configure --disable-static	\
	--disable-rpath		\
	--disable-xpdf		\
	--with-qt=/usr

# build with --as-needed and disable rpath
sed -i \
	-e 's! -shared ! -Wl,--as-needed\0!g' 					\
	-e '/sys_lib_dlsearch_path_spec=\"\/lib \/usr\/lib /s!\"\/lib \/usr\/lib !/\"/%_lib /usr/%_lib !g'	\
	libtool

# not SMP safe
make # %{?_smp_mflags}
	


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'

rm -f $RPM_BUILD_ROOT%plugindir/libextractor_thumbnail.so

echo '%defattr(-,root,root,-)' > filelists.base

for i in $RPM_BUILD_ROOT%plugindir/*.so; do
	readelf -a "$i" | \
	sed '/(NEEDED)/s!.*\[\(.*\)\].*!\1!p;d' | {
		target=base
		fname=${i##$RPM_BUILD_ROOT}
		while read lib; do
			lib=${lib%%.so*}
			case $lib in
				(libz|libdl)				;;
				(libextractor|libextractor_common)	;;
				(libc|libm|libpthread)	;;
				(*)
					target=other
					echo "$fname -> $lib"
					;;
			esac
		done

		case $target in
			(base)	echo "$fname" >> filelists.base;;
		esac
	}
done

ln -s dummy $RPM_BUILD_ROOT%plugindir/libextractor-thumbnail.so
rm -f $RPM_BUILD_ROOT%_infodir/dir

mv $RPM_BUILD_ROOT%_bindir/{,libextractor-}extract
mv $RPM_BUILD_ROOT%_mandir/man1/{,libextractor-}extract.1

%find_lang libextractor


%clean
rm -rf $RPM_BUILD_ROOT


%post
/sbin/ldconfig
/sbin/install-info --info-dir %_infodir %_infodir/extractor.info || :

%preun
test $1 != 0 || /sbin/install-info --info-dir %_infodir --delete %_infodir/extractor.info || :

%postun -p /sbin/ldconfig


%if %{_with_gtk}
%post  plugins-thumbnailgtk
/usr/sbin/update-alternatives --install \
	%plugindir/libextractor_thumbnail.so   libextractor_thumbnail %plugindir/libextractor_thumbnailgtk.so 10

%preun plugins-thumbnailgtk
test "$1" != 0 || \
	/usr/sbin/update-alternatives --remove libextractor_thumbnail %plugindir/libextractor_thumbnailgtk.so
%endif

%if %{?_with_qt}
%post  plugins-thumbnailqt
/usr/sbin/update-alternatives --install \
	%plugindir/libextractor_thumbnail.so   libextractor_thumbnail %plugindir/libextractor_thumbnailqt.so  20

%preun plugins-thumbnailqt
test "$1" != 0 || \
	/usr/sbin/update-alternatives --remove libextractor_thumbnail %plugindir/libextractor_thumbnailqt.so
%endif


%files -f libextractor.lang
%defattr(-,root,root,-)
%doc AUTHORS COPYING ChangeLog NEWS PLATFORMS README* TODO
%_bindir/*
%_libdir/*.so.*
%_infodir/*info*
%_mandir/man1/*
%dir %plugindir

%files plugins
%files plugins-base -f filelists.base

%files devel
%defattr(-,root,root,-)
%doc
%_includedir/*
%_libdir/*.so
%_mandir/man3/*
%_libdir/pkgconfig/*


%changelog
* Thu May 28 2009 Jeff Sheltren <jeff@osuosl.org> - 0.5.22-2
- Rebuild for EL5
- disable flac and qt packages by default
- el4 package disables gtk and re-write some of the conditional statements

* Sat Mar  7 2009 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.22-1
- updated to 0.5.22
- disabled rpm plugin for now as it does not build with rpm-4.6
- disabled builtin xpdf plugin

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.5.20b-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Nov 26 2008 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.21-1
- updated to 0.5.21
- added -rpm plugin

* Wed Jul 16 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.5.20b-2
- fix license tag

* Sat Jun 21 2008 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.20b-1
- updated to 0.5.20b (SECURITY); fixes CVE-2008-1693 (xpdf embedded
  font vulnerability)
- build with -Wl,-as-needed
- fixed rpath issues

* Wed Feb 13 2008 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.19a-1
- updated to 0.5.19a
- added flac-plugin subpackage

* Sat Aug 25 2007 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.18a-1
- updated to 0.5.18a
- renamed 'extract' program to 'libextractor-extract'
- installed info file

* Sat Feb  3 2007 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.17a-1
- updated to 0.5.17a
- fixed URL
- removed -debug patch and the fixups in %%prep which were fixed
  upstream too

* Tue Jan  2 2007 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.17-2
- disabled debug messages
- fixed pkgconfig installation dir

* Tue Jan  2 2007 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.17-1
- updated to 0.5.17
- fixed 'datadir' brokeness
- added pkgconfig files

* Thu Dec 28 2006 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.16-4
- %%ghost'ified the files created by 'update-alternatives'
- initial fedora release (review #214087)
- removed glib-devel BR (should be glib2-devel which is implicated by gtk2-devel)

* Wed Dec 27 2006 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.16-3
- added a README.fedora
- removed the previously added 'Requires: plugin(%%name)'
- added the pdf plugin to the requirements of the -plugins subpackage

* Thu Dec 14 2006 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.16-2
- added a requirement for plugins to the main package
- do not ship README.debian anymore
- improved URL:

* Fri Nov 24 2006 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.16-1
- updated to 0.5.16; handling of libgsf linking of main library needs
  some rethinking: adding such a heavy dependency just to workaround a
  problem in one plugin is not acceptably

* Thu Nov  2 2006 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.15-2
- updated to 0.5.15

* Sun Oct  8 2006 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0.5.14-1
- initial built
